package com.huimv.admin.controller;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.admin.common.utils.Result;
import com.huimv.admin.entity.EnergyData;
import com.huimv.admin.entity.EnergyEnvDevice;
import com.huimv.admin.entity.vo.WaterAndElectricity;
import com.huimv.admin.service.IEnergyDataService;
import com.huimv.admin.service.IEnergyEnvDeviceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 耗能数据 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-02-14
 */
@RestController
@RequestMapping("/energy-data")
@CrossOrigin
public class EnergyDataController {

    @Autowired
    private IEnergyDataService iEnergyDataService;
    @Autowired
    private IEnergyEnvDeviceService deviceService;

    @RequestMapping("/listCount")
    public Result listCount(HttpServletRequest httpServletRequest, @RequestBody Map<String,String> paramsMap) {
        return iEnergyDataService.listCount(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listData")
    public Result listData(HttpServletRequest httpServletRequest, @RequestBody Map<String,String> paramsMap) {
        return iEnergyDataService.listData(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listRank")
    public Result listRank(HttpServletRequest httpServletRequest, @RequestBody Map<String,String> paramsMap) {
        return iEnergyDataService.listRank(httpServletRequest, paramsMap);
    }

    //大屏
    @RequestMapping("/listDataScreen")
    public Result listDataScreen(HttpServletRequest httpServletRequest, @RequestBody Map<String,String> paramsMap) {
        return iEnergyDataService.listDataScreen(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listRankScreen")
    public Result listRankScreen(HttpServletRequest httpServletRequest, @RequestBody Map<String,String> paramsMap) {
        return iEnergyDataService.listRankScreen(httpServletRequest, paramsMap);
    }


    @RequestMapping("/getData")
    public void getData( @RequestBody List<WaterAndElectricity> result) {
//        List<WaterAndElectricity> result = (List) paramsMap.get("result");
        System.out.println("接受到的数据格式:"+result);
        for (WaterAndElectricity jsonObject : result) {
            EnergyData energyData = new EnergyData();
            energyData.setFeedValue("0.00");
            energyData.setWaterValue(jsonObject.getWater());
            energyData.setElectricityValue(jsonObject.getElectricity());
            energyData.setGasValue("0.00");
            energyData.setFarmId(26);
            energyData.setCreateDate(new Date());
            QueryWrapper<EnergyEnvDevice> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("farm_id", 26).eq("device_code", jsonObject.getDeviceCode());
            EnergyEnvDevice device = deviceService.getOne(queryWrapper);
            energyData.setUnitId(device.getUnitId());
            iEnergyDataService.save(energyData);
        }
    }
}
