package com.huimv.receive.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.receive.common.utils.Result;
import com.huimv.receive.common.utils.ResultCode;
import com.huimv.receive.entity.BillAccessDoor;
import com.huimv.receive.entity.BillGate;
import com.huimv.receive.service.IBillAccessDoorService;
import com.huimv.receive.service.IBillGateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 * 车辆闸机信息记录 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-09-25
 */
@RestController
@RequestMapping("/bill-access-door")
@CrossOrigin
public class BillAccessDoorController {

    @Autowired
    private IBillAccessDoorService doorService;
    @Autowired
    private IBillGateService gateService;
    @RequestMapping("/listById")
    public Result listById(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        String farmId = paramsMap.get("farmId");
        String type = paramsMap.get("type");//1为人脸门禁 2为车辆闸机
        String id = paramsMap.get("id");
        if ("1".equals(type)) {
            BillAccessDoor doorServiceOne = doorService.getOne(new QueryWrapper<BillAccessDoor>().eq("farm_id", farmId).eq("id", id));
            return new Result(ResultCode.SUCCESS, doorServiceOne);
        } else {
            BillGate gate = gateService.getOne(new QueryWrapper<BillGate>().eq("farm_id", farmId).eq("id", id));
            return new Result(ResultCode.SUCCESS, gate);
        }

    }
}
